<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    version="1.0">
    
    <xsl:template match="/">
        <html>
            <head><title>Stadtliste von
               <xsl:for-each select="//stadt/name">
                   <xsl:value-of select="."/>
                   <xsl:if test="parent::stadt/following-sibling::stadt/name">
                       <xsl:text>, </xsl:text>
                   </xsl:if>
               </xsl:for-each>
            </title></head>
            <body>
                <h1>Stadtliste von
                    <xsl:for-each select="//stadt/name">
                        <xsl:value-of select="."/>
                        <xsl:if test="parent::stadt/following-sibling::stadt/name">
                            <xsl:text>, </xsl:text>
                        </xsl:if>
                    </xsl:for-each></h1>
                <xsl:apply-templates/>
            </body>
        </html>
    </xsl:template>
    
    <xsl:template match="staedte">
        <ol>
            <xsl:apply-templates/>
        </ol>
    </xsl:template>
    
    <xsl:template match="stadt[name or beschreibung]">
        <li><a name="{name}"/>
            <xsl:apply-templates/>
        </li>
    </xsl:template>
    
    <xsl:template match="stadt[not(child::*)]">
        <xsl:choose>
            <xsl:when test="//stadt[name=current()/text()]">
                <a href="#{.}"><xsl:value-of select="."/></a>
            </xsl:when>
            <xsl:otherwise>
                <xsl:apply-templates/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    
    <xsl:template match="*">
        <span style="font-weight:bold"><xsl:value-of select="name()"/></span>
        <xsl:text>: </xsl:text>
        <xsl:apply-templates/>
        <br/>
    </xsl:template>
    
</xsl:stylesheet>